<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <!--      <el-form-item label="文件名称" prop="filename">-->
      <!--        <el-input v-model="formData.filename" placeholder="请输入文件名称" />-->
      <!--      </el-form-item>-->
      <el-form-item label="附件" prop="filePath" style="">
        <UploadFileAll style="vertical-align: middle"
          :is-show-tip="false"
          v-model="formData.filePath"
          :multiple="formType === 'create'"
          :limit="formType === 'create' ? 5 : 1"
        />
      </el-form-item>
      <el-form-item label="文件类型" prop="fileType">
        <el-select v-model="formData.fileType" placeholder="请选择">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.PMS_FILE_TYPE)"
            :key="dict.label"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="备注" prop="remark">
        <el-input v-model="formData.remark" type="textarea" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotInfoApi, IotInfoVO } from '@/api/pms/iotinfo'
import { DICT_TYPE, getStrDictOptions } from '@/utils/dict'

/** 资料 表单 */
defineOptions({ name: 'IotInfoForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceId: undefined,
  deptId: undefined,
  filename: undefined,
  fileType: undefined,
  filePath: undefined,
  remark: undefined,
  fileList: []
})
const formRules = reactive({
  // deviceId: [{ required: true, message: '设备不能为空', trigger: 'blur' }],
  // orgId: [{ required: true, message: '部门不能为空', trigger: 'blur' }],
  // filename: [{ required: true, message: '文件名称不能为空', trigger: 'blur' }],
  // fileType: [{ required: true, message: '文件类型不能为空', trigger: 'change' }],
  filePath: [{ required: true, message: '文件不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
const props = defineProps<{
  deviceId: string
  classId: string
}>()
/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotInfoApi.getIotInfo(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    formData.value.fileList = formData.value.filePath
    formData.value.filePath = ''
    const data = formData.value as unknown as IotInfoVO

    if (formType.value === 'create') {
      data.classId = props.classId
      data.deviceId = props.deviceId
      // data.filePath = data.filePath.join(',')
      await IotInfoApi.createIotInfo(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotInfoApi.updateIotInfo(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceId: undefined,
    deptId: undefined,
    filename: undefined,
    fileType: undefined,
    filePath: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>
